/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.individu;

import java.awt.BorderLayout;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.modele.interfaces.INomenclature;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.mangue.individu.EOIndividuDistinction;

import com.webobjects.eointerface.EODisplayGroup;


/**
 *
 * @author  cpinsard
 */
public class DistinctionsView extends JFrame {

    /**
	 * 
	 */
	private static final long serialVersionUID = -6195866169790317637L;
	protected EODisplayGroup eod, eodNiveau, eodDistinction;
	protected ZEOTable myEOTable, myEOTableNiveau, myEOTableDistinction;
	protected ZEOTableModel myTableModel, myTableModelNiveau, myTableModelDistinction;
	protected TableSorter myTableSorter, myTableSorterNiveau, myTableSorterDistinction;

	/** Creates new form TemplateJDialog */
    public DistinctionsView(java.awt.Frame parent, EODisplayGroup dg, EODisplayGroup dgNiveau, EODisplayGroup dgDistinction, boolean modal) {

    	// super(parent, modal);
    	eod = dg;
    	eodNiveau = dgNiveau;
    	eodDistinction = dgDistinction;
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewDistinctions = new javax.swing.JPanel();
        viewSaisie = new javax.swing.JPanel();
        btnValider = new javax.swing.JButton();
        btnAnnuler = new javax.swing.JButton();
        jLabel18 = new javax.swing.JLabel();
        tfDateDistinction = new javax.swing.JTextField();
        viewTableDistinction = new javax.swing.JPanel();
        viewTableNiveau = new javax.swing.JPanel();
        viewTable = new javax.swing.JPanel();
        btnModifier = new javax.swing.JButton();
        btnSupprimer = new javax.swing.JButton();
        btnAjouter = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Gestion des distinctions");

        viewSaisie.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        btnValider.setText("Valider");
        btnValider.setToolTipText("Valider la saisie");
        btnValider.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValiderActionPerformed(evt);
            }
        });

        btnAnnuler.setText("Annuler");
        btnAnnuler.setToolTipText("Annuler la saisie");
        btnAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAnnulerActionPerformed(evt);
            }
        });

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel18.setText("Date");

        tfDateDistinction.setEditable(false);
        tfDateDistinction.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateDistinction.setToolTipText("");

        viewTableDistinction.setLayout(new java.awt.BorderLayout());

        viewTableNiveau.setLayout(new java.awt.BorderLayout());

        org.jdesktop.layout.GroupLayout viewSaisieLayout = new org.jdesktop.layout.GroupLayout(viewSaisie);
        viewSaisie.setLayout(viewSaisieLayout);
        viewSaisieLayout.setHorizontalGroup(
            viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewSaisieLayout.createSequentialGroup()
                .addContainerGap(361, Short.MAX_VALUE)
                .add(btnAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnValider, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 96, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .add(viewSaisieLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewSaisieLayout.createSequentialGroup()
                        .add(viewTableNiveau, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 210, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableDistinction, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 205, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(tfDateDistinction, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 98, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(79, Short.MAX_VALUE))
        );
        viewSaisieLayout.setVerticalGroup(
            viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, viewSaisieLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(viewTableDistinction, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 164, Short.MAX_VALUE)
                    .add(viewTableNiveau, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 164, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel18)
                    .add(tfDateDistinction, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSaisieLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnAnnuler)
                    .add(btnValider))
                .addContainerGap())
        );

        viewTable.setLayout(new java.awt.BorderLayout());

        btnModifier.setToolTipText("Modification de la distinction sélectionnée");

        btnSupprimer.setToolTipText("Suppression de la distinction sélectionnée");

        btnAjouter.setToolTipText("Ajout d'une distinction");

        org.jdesktop.layout.GroupLayout viewDistinctionsLayout = new org.jdesktop.layout.GroupLayout(viewDistinctions);
        viewDistinctions.setLayout(viewDistinctionsLayout);
        viewDistinctionsLayout.setHorizontalGroup(
            viewDistinctionsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, viewDistinctionsLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewDistinctionsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewSaisie, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(viewDistinctionsLayout.createSequentialGroup()
                        .add(viewTable, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 539, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(viewDistinctionsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnModifier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnAjouter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(154, Short.MAX_VALUE))
        );
        viewDistinctionsLayout.setVerticalGroup(
            viewDistinctionsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewDistinctionsLayout.createSequentialGroup()
                .add(21, 21, 21)
                .add(viewDistinctionsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTable, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 116, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(viewDistinctionsLayout.createSequentialGroup()
                        .add(btnAjouter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnModifier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(18, 18, 18)
                .add(viewSaisie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(144, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewDistinctions, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(89, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewDistinctions, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 542, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(156, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-850)/2, (screenSize.height-747)/2, 850, 747);
    }// </editor-fold>//GEN-END:initComponents

    private void btnAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAnnulerActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_btnAnnulerActionPerformed

    private void btnValiderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValiderActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_btnValiderActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	DistinctionsView dialog = new DistinctionsView(new javax.swing.JFrame(), null, null, null, true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAjouter;
    protected javax.swing.JButton btnAnnuler;
    private javax.swing.JButton btnModifier;
    private javax.swing.JButton btnSupprimer;
    protected javax.swing.JButton btnValider;
    private javax.swing.JLabel jLabel18;
    protected javax.swing.JTextField tfDateDistinction;
    private javax.swing.JPanel viewDistinctions;
    private javax.swing.JPanel viewSaisie;
    private javax.swing.JPanel viewTable;
    private javax.swing.JPanel viewTableDistinction;
    private javax.swing.JPanel viewTableNiveau;
    // End of variables declaration//GEN-END:variables
    
    private void initGui() {

    	btnAjouter.setIcon(CocktailIcones.ICON_ADD);
    	btnModifier.setIcon(CocktailIcones.ICON_UPDATE);
    	btnSupprimer.setIcon(CocktailIcones.ICON_DELETE);

    	btnValider.setIcon(CocktailIcones.ICON_VALID);
    	btnAnnuler.setIcon(CocktailIcones.ICON_CANCEL);

    	Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EOIndividuDistinction.TO_DISTINCTION_NIVEAU_KEY + "." + INomenclature.LIBELLE_LONG_KEY, "Niveau", 125);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, EOIndividuDistinction.TO_DISTINCTION_KEY+"." + INomenclature.LIBELLE_LONG_KEY, "Distinction", 125);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);
    	 col = new ZEOTableModelColumn(eod, EOIndividuDistinction.DATE_DISTINCTION_KEY, "Date", 150);
    	col.setAlignment(SwingConstants.LEFT);
		col.setFormatDisplay(CocktailFormats.FORMAT_DATE_DDMMYYYY);
		col.setColumnClass(Date.class);
    	myCols.add(col);

    	myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.BG_COLOR_WHITE);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);
		
		
    	myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eodNiveau, INomenclature.LIBELLE_LONG_KEY, "Niveau", 125);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);

    	myTableModelNiveau = new ZEOTableModel(eodNiveau, myCols);
		myTableSorterNiveau = new TableSorter(myTableModelNiveau);

		myEOTableNiveau = new ZEOTable(myTableSorterNiveau);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterNiveau.setTableHeader(myEOTableNiveau.getTableHeader());		

		myEOTableNiveau.setBackground(CocktailConstantes.BG_COLOR_WHITE);
		myEOTableNiveau.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableNiveau.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		
		viewTableNiveau.setLayout(new BorderLayout());
		viewTableNiveau.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableNiveau.removeAll();
		viewTableNiveau.add(new JScrollPane(myEOTableNiveau), BorderLayout.CENTER);

		
    	myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eodDistinction, INomenclature.LIBELLE_LONG_KEY, "Distinction", 125);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);


    	myTableModelDistinction = new ZEOTableModel(eodDistinction, myCols);
		myTableSorterDistinction = new TableSorter(myTableModelDistinction);

		myEOTableDistinction = new ZEOTable(myTableSorterDistinction);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterDistinction.setTableHeader(myEOTableDistinction.getTableHeader());		

		myEOTableDistinction.setBackground(CocktailConstantes.BG_COLOR_WHITE);
		myEOTableDistinction.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableDistinction.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		
		viewTableDistinction.setLayout(new BorderLayout());
		viewTableDistinction.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableDistinction.removeAll();
		viewTableDistinction.add(new JScrollPane(myEOTableDistinction), BorderLayout.CENTER);

    }

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	public ZEOTable getMyEOTableNiveau() {
		return myEOTableNiveau;
	}

	public void setMyEOTableNiveau(ZEOTable myEOTableNiveau) {
		this.myEOTableNiveau = myEOTableNiveau;
	}

	public ZEOTable getMyEOTableDistinction() {
		return myEOTableDistinction;
	}

	public void setMyEOTableDistinction(ZEOTable myEOTableDistinction) {
		this.myEOTableDistinction = myEOTableDistinction;
	}

	public javax.swing.JButton getBtnAjouter() {
		return btnAjouter;
	}

	public void setBtnAjouter(javax.swing.JButton btnAjouter) {
		this.btnAjouter = btnAjouter;
	}

	public javax.swing.JButton getBtnAnnuler() {
		return btnAnnuler;
	}

	public void setBtnAnnuler(javax.swing.JButton btnAnnuler) {
		this.btnAnnuler = btnAnnuler;
	}

	public javax.swing.JButton getBtnModifier() {
		return btnModifier;
	}

	public void setBtnModifier(javax.swing.JButton btnModifier) {
		this.btnModifier = btnModifier;
	}

	public javax.swing.JButton getBtnSupprimer() {
		return btnSupprimer;
	}

	public void setBtnSupprimer(javax.swing.JButton btnSupprimer) {
		this.btnSupprimer = btnSupprimer;
	}

	public javax.swing.JButton getBtnValider() {
		return btnValider;
	}

	public void setBtnValider(javax.swing.JButton btnValider) {
		this.btnValider = btnValider;
	}

	public javax.swing.JTextField getTfDateDistinction() {
		return tfDateDistinction;
	}

	public void setTfDateDistinction(javax.swing.JTextField tfDateDistinction) {
		this.tfDateDistinction = tfDateDistinction;
	}

	public javax.swing.JPanel getViewDistinctions() {
		return viewDistinctions;
	}

	public void setViewDistinctions(javax.swing.JPanel viewDistinctions) {
		this.viewDistinctions = viewDistinctions;
	}

	public javax.swing.JPanel getViewSaisie() {
		return viewSaisie;
	}

	public void setViewSaisie(javax.swing.JPanel viewSaisie) {
		this.viewSaisie = viewSaisie;
	}

	public javax.swing.JPanel getViewTable() {
		return viewTable;
	}

	public void setViewTable(javax.swing.JPanel viewTable) {
		this.viewTable = viewTable;
	}

	public javax.swing.JPanel getViewTableDistinction() {
		return viewTableDistinction;
	}

	public void setViewTableDistinction(javax.swing.JPanel viewTableDistinction) {
		this.viewTableDistinction = viewTableDistinction;
	}

	public javax.swing.JPanel getViewTableNiveau() {
		return viewTableNiveau;
	}

	public void setViewTableNiveau(javax.swing.JPanel viewTableNiveau) {
		this.viewTableNiveau = viewTableNiveau;
	}

	public ZEOTableModel getMyTableModel() {
		return myTableModel;
	}

	public void setMyTableModel(ZEOTableModel myTableModel) {
		this.myTableModel = myTableModel;
	}

	public ZEOTableModel getMyTableModelNiveau() {
		return myTableModelNiveau;
	}

	public void setMyTableModelNiveau(ZEOTableModel myTableModelNiveau) {
		this.myTableModelNiveau = myTableModelNiveau;
	}

	public ZEOTableModel getMyTableModelDistinction() {
		return myTableModelDistinction;
	}

	public void setMyTableModelDistinction(ZEOTableModel myTableModelDistinction) {
		this.myTableModelDistinction = myTableModelDistinction;
	}


}
